import ply.lex as lex
import ply.yacc as yacc

class Compiler(object):
    def __init__(self):
        self.quelltext = None

    def setQuelltext(self, q):
        self.quelltext = q

    def kompilieren(self):
        tokens = ['S','R', 'L', 'ZH', 'ZA', 'WH_ANF', 'WH_END', 'NZ', 'NW']

        # Token
        t_S    = r's'
        t_R    = r'r'
        t_L    = r'l'
        t_ZH    = r'zh'
        t_ZA    = r'za'
        t_WH_ANF    = r'wh'
        t_WH_END    = r'\*wh'
        t_NZ    = r'nz'
        t_NW    = r'nw'

        # Ignorierte Zeichen
        t_ignore = " \t"

        def t_newline(t):
            r'\n+'
            t.lexer.lineno += t.value.count("\n")

        def t_error(t):
            print("Illegal character '%s'" % t.value[0])
            t.lexer.skip(1)

        # Erzeugung des Scanners

        lex.lex()

#-----------------------------------------------------------

        """
        programm : anweisungsfolge
        anweisungsfolge : anweisung | anweisung anweisungsfolge
        anweisung : S | L | R | ZH | ZA | WH_ANF bedingung anweisungsfolge WH_END
        bedingung : NW | NZ
        """


        def p_programm(p):
            'programm : anweisungsfolge'
            p[0] = p[1]

        def p_anweisungsfolge(p):
            '''anweisungsfolge : anweisung anweisungsfolge
                               | anweisung'''
            try:
                p[0] = [p[1]] + p[2]
            except:
                p[0] = [p[1]]

        def p_anweisung(p):
            '''anweisung : S
                         | L
                         | R
                         | ZH
                         | ZA
                         | WH_ANF bedingung anweisungsfolge WH_END'''
            if p[1] == "wh":
                p[0] = [p[1]] + [[p[2]]] + [p[3]]
            else:
                p[0] = [p[1]]

        def p_bedingung(p):
            '''bedingung : NW
                         | NZ'''
            p[0] = p[1]

        def p_error(p):
            print("Syntax error at '%s'" % p.value)


        # import

        yacc.yacc()


        return yacc.parse(self.quelltext)

